! PD-SCALES.CMD
!  Create a Pure Data file using tuning data from scale memory
!  by Greg Schiemer 2005
!
!
ECHO Play current scale with PD (Pure Data)
CLS
SET PAUSE ON
SET SEPARATOR
SET CALC_OUT SHORT
!
ECHO
ECHO ___________________________ PD-SCALE-PLAYER ________________________
ECHO
ECHO Load a scale file from Scala's Scales Archive then run this command 
ECHO which exports it into Pure Data - or PD - by Miller Puckette.
ECHO PD is a freeware cross-platform programming language for music and 
ECHO multimedia composition. Find installers for Linux, PC(XP), Mac OSX
ECHO at http://at.or.at/hans/pd/installers.html
ECHO ____________________________________________________________________
ECHO
ECHO Currently loaded scale is %scl() 
ECHO
ECHO %desc(0)
!
SHOW 0
ECHO
ECHO Press [Enter] to proceed 
ECHO ?
!
COPY 0 8
!
! Customise template of ordinals to control display
! scale size customises number of lines displayed
!
FILE ordinal.cmd
ECHO ! ordinal.cmd
ECHO ! This command is a template generated by PD-Scale-Player.cmd
ECHO !
ECHO HARMONIC 1 %n(8)
CLOSE
!
!
! Define display coordinates for each of the four columns
!
INPUT/LINE
40 80 200 305
COPY 0 5
CLEAR 0
!
! Generate ordinals
!
@ordinal.cmd
COPY 0 9
INSERT 1 1
COPY 0 7
SHOW/LINE 0
ECHO
!
COPY 0 1
CLEAR 0
!
! Define size of each column
! (i.e. number of lines customised by ordinal.cmd)
!
! Use vertical spacing of 11 points
!
ITERATE/scale "INSERT 1 11" 1
ADD 1
ECHO Y-coordinates
SHOW/LINE 0
!
! Store column co-ordinates in scale memories 1 2 3 and 4
!
COPY 0 1
COPY 0 2
COPY 0 3
COPY 0 4
!
COPY 8 0
!
SET PAUSE on
!
! Generate PD Scale template
!
FILE SCALE.PD
!
!
! Main Canvas
!
! Below this point observe PD syntax when using ECHO
!
echo #N canvas 24 5 750 350 10;
echo #X text 5 16 %desc(0);
!
echo #X text 7   225 Exported from Scala;
echo #X text 201 225 G. Schiemer 2005;
echo #X text 7   305 Scala is a tuning analysis-editor-librarian tool; 
echo #X text 7   315 written by Manuel Op de Coul. It is available as;
echo #X text 7   325 freeware :- http://www.xs4all.nl/~huygensf/scala;
!
!
!
! Canvas 1
!
echo #N canvas 0 0 400 550 Help 0;
!
! About Microtonal Player
!
echo #X text 10 10  Microtonal player written by G. Schiemer 2005;
echo #X text 10 40  This player allows users to experiment with microtonal tunings in Pure Data;
echo #X text 10 70  Tunings are generated in Scala and exported to Pure Data;
echo #X text 10 100 In this player;
echo #X text 20 120 1. Colour-coded keyboards labelled 'keyboard' are;
echo #X text 30 135 played manually or driven from a sequencer;
echo #X text 30 150 - range of each keyboard voice is selected manually;
echo #X text 40 165 using 'mode' and 'octave';
echo #X text 20 190 2. Melodic contour is modified using binary switches;
echo #X text 30 205 - clear all switches to play ascending scale; 
echo #X text 30 220 - set all switches to play descending scales; 
echo #X text 20 245 3. Each voice is manually enabled or disabled using;
echo #X text 30 260 its corresponding 'mute' button;
echo #X text 30 275 - any 1 of 8 combinations of 3 voices is selected;
echo #X text 40 290 by a single button operation using 'voices';
echo #X text 30 305 - sequencer clock is started or stopped;
echo #X text 40 320 using 'master' button;
echo #X text 20 345 4. Each voice has a clock that is manually enabled;
echo #X text 30 360 or disabled using its corresponding button;
echo #X text 30 375 - any 1 of 8 combinations of 3 'clocks' can be;
echo #X text 40 390 sequenced by a single button operation;
echo #X text 20 415 5. Specification of each scale step is displayed;
echo #X text 30 430 by opening .scl on the main canvas;
echo #X text 30 445 - new scales can be played by running the;
echo #X text 20 470 6. Scala command file with a new scale selected;
echo #X text 30 485 - keyboard size is automatically determined by scale chosen;
echo #X text 10 510 Changes to this file may be made either in PD or by modifying Scala scripts - Greg S;
echo #X restore 255 265 pd Help ;
!
!
!
! Canvas 2 - display scale
!
echo #X obj 45 68 cnv 15 254 99 empty empty %scl() -40 -60 0 16 -212343 -258699 0;
!
! Here are 2 of 4 steps to extend this canvas horizontally for scales with more than 30 notes per octave
!
! 	[a] disable the canvas above (i.e. by inserting exclamation mark before 'echo' in column 1)
!  
! 	[b] enable the canvas below  (i.e. by removing exclamation mark before 'echo' in column 1)
!
!echo #X obj 45 68 cnv 15 1022 99 empty empty %scl() -35 -60 0 10 -212343 -66577 0;
!
! Create array of linear factors
!
echo #N canvas 0 0 450 168 graph1 0;
echo #X array scale %n+1(0) float 1;
echo #A 0 1 %listfactor(0) \:;
echo #X coords 0 2 %n(0) 1 256 100 1;
!
! And here are the remaining 2 of 4 steps for scales with more than 30 notes per octave
!
! 	[c] disable the coords above
!
!	   and
!
! 	[d] enable the coords above
!
!echo #X coords 0 2 %n(0) 1 1024 100 1;
!
ECHO #X restore 44 67 graph;
!
!
!
! Canvas 3 - Display scale specifications
!
ECHO #N canvas 30 410 563 298 %scl() 1;
ECHO #X obj 0 0 cnv 8 565 300 empty empty empty 8 15 10 12 -212343 -66577 0;
!
! First line of each column is read out separately
! All other lines of each are read out iteratively
!
! column 1 - Ordinals
!
!            x-coord 1  y-coord 1
ECHO #X text %num(%1%5) %num(%i%1) 0:;
!                           x-coord 1  y-coords   scale degree
ITERATE/SCALE "echo #X text %num(%1%5) %num(%i%1) %num(%i%7):;" 8
! 
! column 2 - JI ratio (or cents)
!
!            x-coord 2  y-coord 1
ECHO #X text %num(%2%5) %num(%i%2) %image(%0%0);
!                           x-coord 2  y-coords   ji ratio or cents
ITERATE/SCALE "echo #X text %num(%2%5) %num(%i%2) %image(%i%0);" 8
! 
! column 3 - Linear factors
!
!            x-coord 3  y-coord 1
ECHO #X text %num(%3%5) %num(%i%3) %factor(%0%0);
!                           x-coord 3  y-coords   linear factor
ITERATE/SCALE "echo #X text %num(%3%5) %num(%i%3) %factor(%i%0);" 8
! 
! column 4 - Historical names
!
!            x-coord 4  y-coord 1
ECHO #X text %num(%4%5) %num(%i%4) :%name(%0%0);
!                           x-coord 4  y-coords   historical name
ITERATE/SCALE "echo #X text %num(%4%5) %num(%i%4) :%name(%i%0);" 8
ECHO #X restore 190 200 pd %scl();
!
!
!
! Main Canvas (continued) - Scale player is specifically related to PD syntax
!
!
! Caution - line order is important
! Connections may break if objects are not inserted thoughtfully (see below)
!
echo #X obj 476 200 vsl    10 92 0 1     0 1 vol vinit  M 	 2 -8 0 8 -262144 -1 -1 0 1;
echo #X obj 488 200 vsl    10 92 0 1     0 1 v1  vinit1 1        1 -8 0 8 -109622 -1 -1 0 1;
echo #X obj 500 200 vsl    10 92 0 1     0 1 v2  vinit2 2        1 -8 0 8 -110363 -1 -1 0 1;
echo #X obj 512 200 vsl    10 92 0 1     0 1 v3  vinit3 3        1 -8 0 8 -245461 -1 -1 0 1;
echo #X obj 545 200 hradio 10 1  1 %n(0) keyOUT1 keyIN1 Keyboard 0 -6 0 8 -109622 -1 -1 0;
echo #X obj 545 211 hradio 10 1  1 %n(0) keyOUT2 keyIN2 empty    0 -6 0 8 -110363 -1 -1 0;
echo #X obj 545 222 hradio 10 1  1 %n(0) keyOUT3 keyIN3 empty    0 -6 0 8 -245462 -1 -1 0;
echo #X obj 545 255 hradio 10 1  1 %n(0) ModeIN1 Phone1 Mode     0 -6 0 8 -109622 -1 -1 3;
echo #X obj 545 266 hradio 10 1  1 %n(0) ModeIN2 Phone2 empty    0 -6 0 8 -110363 -1 -1 2;
echo #X obj 545 277 hradio 10 1  1 %n(0) ModeIN3 Phone3 empty    0 -6 0 8 -245462 -1 -1 4;
echo #X obj 488 325 tgl    10 0  step1  c1       empty          -16 8 0 8 -109622 -1 -1 1 1;
echo #X obj 500 325 tgl    10 0  step2  c2       empty           16 8 0 8 -81620  -1 -1 1 1;
echo #X obj 512 325 tgl    10 0  step3  c3       empty           16 8 0 8 -245461 -1 -1 1 1;
!
echo #X obj 488 300 tgl    10 0  vinit1 on1 empty 	        -32 4 0 8 -109622 -1 -1 0 0.3;
echo #X obj 500 300 tgl    10 0  vinit2 on2 empty               -32 4 0 8 -110363 -1 -1 0 0.3;
echo #X obj 512 300 tgl    10 0  vinit3 on3 empty               -32 4 0 8 -245461 -1 -1 0 0.3;
echo #X obj 694 303 hradio 10 1  1 4    OctIN1 empty Octave      0 -6 0 8 -109622 -1 -1 0;
echo #X obj 694 314 hradio 10 1  1 4    OctIN2 empty empty       0 -6 0 8 -110363 -1 -1 0;
echo #X obj 694 325 hradio 10 1  1 4    OctIN3 empty empty       0 -6 0 8 -245462 -1 -1 0;
echo #X obj 545 300 hradio 10 1  1 8    cut Phone4 Voices        0 -6 0 8 -259030 -1 -1 7;
echo #X obj 545 325 hradio 10 1  1 8    run Phone5 Clocks        0 -6 0 8 -250685 -1 -1 7;
echo #X obj 5   200 tgl    15 1         load   xyz 1.Load_scale  5  8 0 8 -130072 -1 -1 0 1;
echo #X obj 431 202 tgl    15 0         play   abc 2.Run         5  8 0 8 -130072 -1 -1 0 1;
echo #X obj 476 300 tgl    10 0         vinit  on0 Mute         -32 4 0 8 -259030 -1 -1 0 0.3;
echo #X obj 476 325 tgl    10 1         step0  c0  Master       -44 4 0 8 -250685 -1 -1 0.3 0.3;
echo #X text 383 20 Area immediately below was kept clear to display larger scales - to widen display follow 4-step procedure described in pd-scale-player.cmd (see comments in canvas 2) ;
!
! Caution - insert additional objects starting here. 
! If possible, create sub-patches. These are bounded by 'canvas' and 'restore'
!
!
! Canvas 4 - Bitwise Inverter 1
!
echo #N canvas 0 2 1000 700 BitInv1 0;
! 						 	   Blue   -109622
! 						 	   Green  -110363
! 						 	   Yellow -245462
!
echo #X obj 0 0 cnv 15 100 30 empty empty BitwiseInvert1 0 -6 0 8 -109622 -66577 0;
!
! [0] 1
echo #X obj 120 123 r Xin1;
!
! [1-8] 2-9
echo #X obj 120 152 mod 256;
echo #X obj 220 169 mod 128;
echo #X obj 320 186 mod 64;
echo #X obj 420 203 mod 32;
echo #X obj 520 220 mod 16;
echo #X obj 620 237 mod 8;
echo #X obj 720 254 mod 4;
echo #X obj 820 271 mod 2;
!
! [9-15] 10-16
echo #X obj 120 270 > 127;
echo #X obj 220 270 > 63;
echo #X obj 320 270 > 31;
echo #X obj 420 270 > 15;
echo #X obj 520 270 > 7;
echo #X obj 620 270 > 3;
echo #X obj 720 270 > 1;
!
! [16-23] 17-24
echo #X obj 120 295 t b f;
echo #X obj 220 295 t b f;
echo #X obj 320 295 t b f;
echo #X obj 420 295 t b f;
echo #X obj 520 295 t b f;
echo #X obj 620 295 t b f;
echo #X obj 720 295 t b f;
echo #X obj 820 295 t b f;
!
! [24-32] 25-33
echo #X obj 125 325 tgl 10 1 empty empty 7 2 -5 0 8 -262144 -1 -1 1 1;
echo #X obj 225 325 tgl 10 1 empty empty 6 2 -5 0 8 -262144 -1 -1 1 1;
echo #X obj 325 325 tgl 10 1 empty empty 5 2 -5 0 8 -262144 -1 -1 0 1;
echo #X obj 425 325 tgl 10 1 empty empty 4 2 -5 0 8 -262144 -1 -1 1 1;
echo #X obj 525 325 tgl 10 1 empty empty 3 2 -5 0 8 -262144 -1 -1 0 1;
echo #X obj 625 325 tgl 10 1 empty empty 2 2 -5 0 8 -262144 -1 -1 1 1;
echo #X obj 725 325 tgl 10 1 empty empty 1 2 -5 0 8 -262144 -1 -1 0 1;
echo #X obj 825 325 tgl 10 1 empty empty 0 2 -5 0 8 -262144 -1 -1 1 1;
echo #X obj 120 340 + 1;
!
! [33-39] 34-40
echo #X obj 220 340 + 1;
echo #X obj 320 340 + 1;
echo #X obj 420 340 + 1;
echo #X obj 520 340 + 1;
echo #X obj 620 340 + 1;
echo #X obj 720 340 + 1;
echo #X obj 820 340 + 1;
!
! [40-47] 41-48
echo #X obj 120 370 mod 2;
echo #X obj 220 370 mod 2;
echo #X obj 320 370 mod 2;
echo #X obj 420 370 mod 2;
echo #X obj 520 370 mod 2;
echo #X obj 620 370 mod 2;
echo #X obj 720 370 mod 2;
echo #X obj 820 370 mod 2;
!
! [48-55] 49-56
echo #X obj 120 405 * 128;
echo #X obj 220 405 * 64;
echo #X obj 320 405 * 32;
echo #X obj 420 405 * 16;
echo #X obj 520 405 * 8;
echo #X obj 620 405 * 4;
echo #X obj 720 405 * 2;
echo #X obj 820 405 * 1;
!
! [56] 57
echo #X msg 920 387 \; str1 bang \;;
!
! [57-63] 58-64
echo #X obj 720 422 +;
echo #X obj 620 439 +;
echo #X obj 520 556 +;
echo #X obj 420 473 +;
echo #X obj 320 490 +;
echo #X obj 220 507 +;
echo #X obj 120 524 +;
!
! [64] 65
echo #X obj 120 548 s Xout1;
!
! [65-71] 66-72
echo #X obj 80 405 r str1;
echo #X obj 80 422 r str1;
echo #X obj 80 439 r str1;
echo #X obj 80 456 r str1;
echo #X obj 80 473 r str1;
echo #X obj 80 490 r str1;
echo #X obj 80 507 r str1;
!
! 73-74
echo #X text 200 440 Binary Decoder;
echo #X text 200 220 Binary Encoder;
!
echo #X connect 1  0 2  0;
echo #X connect 2  0 3  0;
echo #X connect 2  0 10 0;
echo #X connect 3  0 4  0;
echo #X connect 3  0 11 0;
echo #X connect 4  0 5  0;
echo #X connect 4  0 12 0;
echo #X connect 5  0 6  0;
echo #X connect 5  0 13 0;
echo #X connect 6  0 7  0;
!
echo #X connect 6  0 14 0;
echo #X connect 7  0 8  0;
echo #X connect 7  0 15 0;
echo #X connect 8  0 9  0;
echo #X connect 8  0 16 0;
echo #X connect 9  0 24 0;
echo #X connect 9  0 40 1;
echo #X connect 10 0 17 0;
echo #X connect 10 0 33 1;
echo #X connect 11 0 18 0;
!
echo #X connect 11 0 34 1;
echo #X connect 12 0 19 0;
echo #X connect 12 0 35 1;
echo #X connect 13 0 20 0;
echo #X connect 13 0 36 1;
echo #X connect 14 0 21 0;
echo #X connect 14 0 37 1;
echo #X connect 15 0 22 0;
echo #X connect 15 0 38 1;
echo #X connect 16 0 23 0;
echo #X connect 16 0 39 1;
!
echo #X connect 17 0 33 0;
echo #X connect 17 1 33 1;
echo #X connect 18 0 34 0;
echo #X connect 18 1 34 1;
echo #X connect 19 0 35 0;
echo #X connect 19 1 35 1;
echo #X connect 20 0 36 0;
echo #X connect 20 1 36 1;
!
echo #X connect 21 0 37 0;
echo #X connect 21 1 37 1;
echo #X connect 22 0 38 0;
echo #X connect 22 1 38 1;
echo #X connect 23 0 39 0;
echo #X connect 23 1 39 1;
echo #X connect 24 0 40 0;
echo #X connect 24 1 40 1;
!
echo #X connect 25 0 33 0;
echo #X connect 26 0 34 0;
echo #X connect 27 0 35 0;
echo #X connect 28 0 36 0;
echo #X connect 29 0 37 0;
echo #X connect 30 0 38 0;
echo #X connect 31 0 39 0;
echo #X connect 32 0 40 0;
!
echo #X connect 33 0 41 0;
echo #X connect 34 0 42 0;
echo #X connect 35 0 43 0;
echo #X connect 36 0 44 0;
echo #X connect 37 0 45 0;
echo #X connect 38 0 46 0;
echo #X connect 39 0 47 0;
echo #X connect 40 0 48 0;
!
echo #X connect 41 0 49 0;
echo #X connect 42 0 50 0;
echo #X connect 43 0 51 0;
echo #X connect 44 0 52 0;
echo #X connect 45 0 53 0;
echo #X connect 46 0 54 0;
echo #X connect 47 0 55 0;
echo #X connect 48 0 56 0;
!
echo #X connect 41 0 57 0;
echo #X connect 42 0 57 0;
echo #X connect 43 0 57 0;
echo #X connect 44 0 57 0;
echo #X connect 45 0 57 0;
echo #X connect 46 0 57 0;
echo #X connect 47 0 57 0;
echo #X connect 48 0 57 0;
!
echo #X connect 49 0 64 0;
echo #X connect 50 0 63 0;
echo #X connect 51 0 62 0;
echo #X connect 52 0 61 0;
echo #X connect 53 0 60 0;
echo #X connect 54 0 59 0;
echo #X connect 55 0 58 0;
!
echo #X connect 56 0 58 1;
echo #X connect 58 0 59 1;
echo #X connect 59 0 60 1;
echo #X connect 60 0 61 1;
echo #X connect 61 0 62 1;
echo #X connect 62 0 63 1;
echo #X connect 63 0 64 1;
!
!echo #X connect 63 0 64 0;
echo #X connect 64 0 65 0;
!
echo #X connect 66 0 58 0;
echo #X connect 67 0 59 0;
echo #X connect 68 0 60 0;
echo #X connect 69 0 61 0;
echo #X connect 70 0 62 0;
echo #X connect 71 0 63 0;
echo #X connect 72 0 64 0;
!
echo #X coords 0 0 1 1 100 30 1;
echo #X restore 320 200 pd BitInv1;
!
! Canvas 5 - Bitwise Inverter 2
!
echo #N canvas 0 2 1000 700 BitInv2 0;
! 						 	   Blue   -109622
! 						 	   Green  -110363
! 						 	   Yellow -245462
!
echo #X obj 0 0 cnv 15 100 30 empty empty BitwiseInvert2 0 -6 0 8 -110363 -66577 0;
!
! [0] 1
echo #X obj 120 123 r Xin2;
!
! [1-8] 2-9
echo #X obj 120 152 mod 256;
echo #X obj 220 169 mod 128;
echo #X obj 320 186 mod 64;
echo #X obj 420 203 mod 32;
echo #X obj 520 220 mod 16;
echo #X obj 620 237 mod 8;
echo #X obj 720 254 mod 4;
echo #X obj 820 371 mod 2;
!
! [9-15] 10-16
echo #X obj 120 270 > 127;
echo #X obj 220 270 > 63;
echo #X obj 320 270 > 31;
echo #X obj 420 270 > 15;
echo #X obj 520 270 > 7;
echo #X obj 620 270 > 3;
echo #X obj 720 270 > 1;
!
! [16-23] 17-24
echo #X obj 120 295 t b f;
echo #X obj 220 295 t b f;
echo #X obj 320 295 t b f;
echo #X obj 420 295 t b f;
echo #X obj 520 295 t b f;
echo #X obj 620 295 t b f;
echo #X obj 720 295 t b f;
echo #X obj 820 295 t b f;
!
! [24-32] 25-33
echo #X obj 125 325 tgl 10 1 empty empty 7 2 -5 0 8 -262144 -1 -1 1 1;
echo #X obj 225 325 tgl 10 1 empty empty 6 2 -5 0 8 -262144 -1 -1 1 1;
echo #X obj 325 325 tgl 10 1 empty empty 5 2 -5 0 8 -262144 -1 -1 0 1;
echo #X obj 425 325 tgl 10 1 empty empty 4 2 -5 0 8 -262144 -1 -1 1 1;
echo #X obj 525 325 tgl 10 1 empty empty 3 2 -5 0 8 -262144 -1 -1 0 1;
echo #X obj 625 325 tgl 10 1 empty empty 2 2 -5 0 8 -262144 -1 -1 1 1;
echo #X obj 725 325 tgl 10 1 empty empty 1 2 -5 0 8 -262144 -1 -1 0 1;
echo #X obj 825 325 tgl 10 1 empty empty 0 2 -5 0 8 -262144 -1 -1 1 1;
echo #X obj 120 340 + 1;
!
! [33-39] 34-40
echo #X obj 220 340 + 1;
echo #X obj 320 340 + 1;
echo #X obj 420 340 + 1;
echo #X obj 520 340 + 1;
echo #X obj 620 340 + 1;
echo #X obj 720 340 + 1;
echo #X obj 820 340 + 1;
!
! [40-47] 41-48
echo #X obj 120 370 mod 2;
echo #X obj 220 370 mod 2;
echo #X obj 320 370 mod 2;
echo #X obj 420 370 mod 2;
echo #X obj 520 370 mod 2;
echo #X obj 620 370 mod 2;
echo #X obj 720 370 mod 2;
echo #X obj 820 370 mod 2;
!
! [48-55] 49-56
echo #X obj 120 405 * 128;
echo #X obj 220 405 * 64;
echo #X obj 320 405 * 32;
echo #X obj 420 405 * 16;
echo #X obj 520 405 * 8;
echo #X obj 620 405 * 4;
echo #X obj 720 405 * 2;
echo #X obj 820 405 * 1;
!
! [56] 57
echo #X msg 920 387 \; str2 bang \;;
!
! [57-63] 58-64
echo #X obj 720 422 +;
echo #X obj 620 439 +;
echo #X obj 520 456 +;
echo #X obj 420 473 +;
echo #X obj 320 490 +;
echo #X obj 220 507 +;
echo #X obj 120 524 +;
!
! [64] 65
echo #X obj 120 548 s Xout2;
!
! [65-71] 66-72
echo #X obj 80 405 r str2;
echo #X obj 80 422 r str2;
echo #X obj 80 439 r str2;
echo #X obj 80 456 r str2;
echo #X obj 80 473 r str2;
echo #X obj 80 490 r str2;
echo #X obj 80 507 r str2;
!
! 73-74
echo #X text 200 440 Binary Decoder;
echo #X text 200 220 Binary Encoder;
!
echo #X connect 1  0 2  0;
echo #X connect 2  0 3  0;
echo #X connect 2  0 10 0;
echo #X connect 3  0 4  0;
echo #X connect 3  0 11 0;
echo #X connect 4  0 5  0;
echo #X connect 4  0 12 0;
echo #X connect 5  0 6  0;
echo #X connect 5  0 13 0;
echo #X connect 6  0 7  0;
!
echo #X connect 6  0 14 0;
echo #X connect 7  0 8  0;
echo #X connect 7  0 15 0;
echo #X connect 8  0 9  0;
echo #X connect 8  0 16 0;
echo #X connect 9  0 24 0;
echo #X connect 9  0 40 1;
echo #X connect 10 0 17 0;
echo #X connect 10 0 33 1;
echo #X connect 11 0 18 0;
!
echo #X connect 11 0 34 1;
echo #X connect 12 0 19 0;
echo #X connect 12 0 35 1;
echo #X connect 13 0 20 0;
echo #X connect 13 0 36 1;
echo #X connect 14 0 21 0;
echo #X connect 14 0 37 1;
echo #X connect 15 0 22 0;
echo #X connect 15 0 38 1;
echo #X connect 16 0 23 0;
echo #X connect 16 0 39 1;
!
echo #X connect 17 0 33 0;
echo #X connect 17 1 33 1;
echo #X connect 18 0 34 0;
echo #X connect 18 1 34 1;
echo #X connect 19 0 35 0;
echo #X connect 19 1 35 1;
echo #X connect 20 0 36 0;
echo #X connect 20 1 36 1;
!
echo #X connect 21 0 37 0;
echo #X connect 21 1 37 1;
echo #X connect 22 0 38 0;
echo #X connect 22 1 38 1;
echo #X connect 23 0 39 0;
echo #X connect 23 1 39 1;
echo #X connect 24 0 40 0;
echo #X connect 24 1 40 1;
!
echo #X connect 25 0 33 0;
echo #X connect 26 0 34 0;
echo #X connect 27 0 35 0;
echo #X connect 28 0 36 0;
echo #X connect 29 0 37 0;
echo #X connect 30 0 38 0;
echo #X connect 31 0 39 0;
echo #X connect 32 0 40 0;
!
echo #X connect 33 0 41 0;
echo #X connect 34 0 42 0;
echo #X connect 35 0 43 0;
echo #X connect 36 0 44 0;
echo #X connect 37 0 45 0;
echo #X connect 38 0 46 0;
echo #X connect 39 0 47 0;
echo #X connect 40 0 48 0;
!
echo #X connect 41 0 49 0;
echo #X connect 42 0 50 0;
echo #X connect 43 0 51 0;
echo #X connect 44 0 52 0;
echo #X connect 45 0 53 0;
echo #X connect 46 0 54 0;
echo #X connect 47 0 55 0;
echo #X connect 48 0 56 0;
!
echo #X connect 41 0 57 0;
echo #X connect 42 0 57 0;
echo #X connect 43 0 57 0;
echo #X connect 44 0 57 0;
echo #X connect 45 0 57 0;
echo #X connect 46 0 57 0;
echo #X connect 47 0 57 0;
echo #X connect 48 0 57 0;
!
echo #X connect 49 0 64 0;
echo #X connect 50 0 63 0;
echo #X connect 51 0 62 0;
echo #X connect 52 0 61 0;
echo #X connect 53 0 60 0;
echo #X connect 54 0 59 0;
echo #X connect 55 0 58 0;
!
echo #X connect 56 0 58 1;
echo #X connect 58 0 59 1;
echo #X connect 59 0 60 1;
echo #X connect 60 0 61 1;
echo #X connect 61 0 62 1;
echo #X connect 62 0 63 1;
echo #X connect 63 0 64 1;
!
!echo #X connect 63 0 64 0;
echo #X connect 64 0 65 0;
!
echo #X connect 66 0 58 0;
echo #X connect 67 0 59 0;
echo #X connect 68 0 60 0;
echo #X connect 69 0 61 0;
echo #X connect 70 0 62 0;
echo #X connect 71 0 63 0;
echo #X connect 72 0 64 0;
!
echo #X coords 0 0 1 1 100 30 1;
echo #X restore 320 254 pd BitInv2;
!
! Canvas 6 - Bitwise Inverter 3 
!
echo #N canvas 0 3 1000 700 BitInv2 0;
! 						 	   Blue   -109622
! 						 	   Green  -110363
! 						 	   Yellow -245462
!
echo #X obj 0 0 cnv 15 100 30 empty empty BitwiseInvert3 0 -6 0 8 -245462 -66577 0;
!
! [0] 1
echo #X obj 120 123 r Xin3;
!
! [1-8] 2-9
echo #X obj 120 152 mod 256;
echo #X obj 220 169 mod 128;
echo #X obj 320 186 mod 64;
echo #X obj 420 203 mod 32;
echo #X obj 520 220 mod 16;
echo #X obj 620 237 mod 8;
echo #X obj 720 254 mod 4;
echo #X obj 820 271 mod 2;
!
! [9-15] 10-16
echo #X obj 120 270 > 127;
echo #X obj 220 270 > 63;
echo #X obj 320 270 > 31;
echo #X obj 420 270 > 15;
echo #X obj 520 270 > 7;
echo #X obj 620 270 > 3;
echo #X obj 720 270 > 1;
!
! [16-23] 17-24
echo #X obj 120 295 t b f;
echo #X obj 220 295 t b f;
echo #X obj 320 295 t b f;
echo #X obj 420 295 t b f;
echo #X obj 520 295 t b f;
echo #X obj 620 295 t b f;
echo #X obj 720 295 t b f;
echo #X obj 820 295 t b f;
!
! [24-32] 25-33
echo #X obj 125 325 tgl 10 1 empty empty 7 2 -5 0 8 -262144 -1 -1 1 1;
echo #X obj 225 325 tgl 10 1 empty empty 6 2 -5 0 8 -262144 -1 -1 1 1;
echo #X obj 325 325 tgl 10 1 empty empty 5 2 -5 0 8 -262144 -1 -1 0 1;
echo #X obj 425 325 tgl 10 1 empty empty 4 2 -5 0 8 -262144 -1 -1 1 1;
echo #X obj 525 325 tgl 10 1 empty empty 3 2 -5 0 8 -262144 -1 -1 0 1;
echo #X obj 625 325 tgl 10 1 empty empty 2 2 -5 0 8 -262144 -1 -1 1 1;
echo #X obj 725 325 tgl 10 1 empty empty 1 2 -5 0 8 -262144 -1 -1 0 1;
echo #X obj 825 325 tgl 10 1 empty empty 0 2 -5 0 8 -262144 -1 -1 1 1;
echo #X obj 120 340 + 1;
!
! [33-39] 34-40
echo #X obj 220 340 + 1;
echo #X obj 320 340 + 1;
echo #X obj 420 340 + 1;
echo #X obj 520 340 + 1;
echo #X obj 620 340 + 1;
echo #X obj 720 340 + 1;
echo #X obj 820 340 + 1;
!
! [40-47] 41-48
echo #X obj 120 370 mod 2;
echo #X obj 220 370 mod 2;
echo #X obj 320 370 mod 2;
echo #X obj 420 370 mod 2;
echo #X obj 520 370 mod 2;
echo #X obj 620 370 mod 2;
echo #X obj 720 370 mod 2;
echo #X obj 820 370 mod 2;
!
! [48-55] 49-56
echo #X obj 120 405 * 128;
echo #X obj 220 405 * 64;
echo #X obj 320 405 * 32;
echo #X obj 420 405 * 16;
echo #X obj 520 405 * 8;
echo #X obj 620 405 * 4;
echo #X obj 720 405 * 2;
echo #X obj 820 405 * 1;
!
! [56] 57
echo #X msg 920 387 \; str3 bang \;;
!
! [57-63] 58-64
echo #X obj 720 422 +;
echo #X obj 620 439 +;
echo #X obj 520 456 +;
echo #X obj 420 473 +;
echo #X obj 320 490 +;
echo #X obj 220 507 +;
echo #X obj 120 524 +;
!
! [64] 65
echo #X obj 120 548 s Xout3;
!
! [65-71] 66-72
echo #X obj 80 405 r str3;
echo #X obj 80 422 r str3;
echo #X obj 80 439 r str3;
echo #X obj 80 456 r str3;
echo #X obj 80 473 r str3;
echo #X obj 80 490 r str3;
echo #X obj 80 507 r str3;
!
! 73-74
echo #X text 200 440 Binary Decoder;
echo #X text 200 220 Binary Encoder;
!
echo #X connect 1  0 2  0;
echo #X connect 2  0 3  0;
echo #X connect 2  0 10 0;
echo #X connect 3  0 4  0;
echo #X connect 3  0 11 0;
echo #X connect 4  0 5  0;
echo #X connect 4  0 12 0;
echo #X connect 5  0 6  0;
echo #X connect 5  0 13 0;
echo #X connect 6  0 7  0;
!
echo #X connect 6  0 14 0;
echo #X connect 7  0 8  0;
echo #X connect 7  0 15 0;
echo #X connect 8  0 9  0;
echo #X connect 8  0 16 0;
echo #X connect 9  0 24 0;
echo #X connect 9  0 40 1;
echo #X connect 10 0 17 0;
echo #X connect 10 0 33 1;
echo #X connect 11 0 18 0;
!
echo #X connect 11 0 34 1;
echo #X connect 12 0 19 0;
echo #X connect 12 0 35 1;
echo #X connect 13 0 20 0;
echo #X connect 13 0 36 1;
echo #X connect 14 0 21 0;
echo #X connect 14 0 37 1;
echo #X connect 15 0 22 0;
echo #X connect 15 0 38 1;
echo #X connect 16 0 23 0;
echo #X connect 16 0 39 1;
!
echo #X connect 17 0 33 0;
echo #X connect 17 1 33 1;
echo #X connect 18 0 34 0;
echo #X connect 18 1 34 1;
echo #X connect 19 0 35 0;
echo #X connect 19 1 35 1;
echo #X connect 20 0 36 0;
echo #X connect 20 1 36 1;
!
echo #X connect 21 0 37 0;
echo #X connect 21 1 37 1;
echo #X connect 22 0 38 0;
echo #X connect 22 1 38 1;
echo #X connect 23 0 39 0;
echo #X connect 23 1 39 1;
echo #X connect 24 0 40 0;
echo #X connect 24 1 40 1;
!
echo #X connect 25 0 33 0;
echo #X connect 26 0 34 0;
echo #X connect 27 0 35 0;
echo #X connect 28 0 36 0;
echo #X connect 29 0 37 0;
echo #X connect 30 0 38 0;
echo #X connect 31 0 39 0;
echo #X connect 32 0 40 0;
!
echo #X connect 33 0 41 0;
echo #X connect 34 0 42 0;
echo #X connect 35 0 43 0;
echo #X connect 36 0 44 0;
echo #X connect 37 0 45 0;
echo #X connect 38 0 46 0;
echo #X connect 39 0 47 0;
echo #X connect 40 0 48 0;
!
echo #X connect 41 0 49 0;
echo #X connect 42 0 50 0;
echo #X connect 43 0 51 0;
echo #X connect 44 0 52 0;
echo #X connect 45 0 53 0;
echo #X connect 46 0 54 0;
echo #X connect 47 0 55 0;
echo #X connect 48 0 56 0;
!
echo #X connect 41 0 57 0;
echo #X connect 42 0 57 0;
echo #X connect 43 0 57 0;
echo #X connect 44 0 57 0;
echo #X connect 45 0 57 0;
echo #X connect 46 0 57 0;
echo #X connect 47 0 57 0;
echo #X connect 48 0 57 0;
!
echo #X connect 49 0 64 0;
echo #X connect 50 0 63 0;
echo #X connect 51 0 62 0;
echo #X connect 52 0 61 0;
echo #X connect 53 0 60 0;
echo #X connect 54 0 59 0;
echo #X connect 55 0 58 0;
!
echo #X connect 56 0 58 1;
echo #X connect 58 0 59 1;
echo #X connect 59 0 60 1;
echo #X connect 60 0 61 1;
echo #X connect 61 0 62 1;
echo #X connect 62 0 63 1;
echo #X connect 63 0 64 1;
!
echo #X connect 64 0 65 0;
!
echo #X connect 66 0 58 0;
echo #X connect 67 0 59 0;
echo #X connect 68 0 60 0;
echo #X connect 69 0 61 0;
echo #X connect 70 0 62 0;
echo #X connect 71 0 63 0;
echo #X connect 72 0 64 0;
!
echo #X coords 0 0 1 1 100 30 1;
echo #X restore 320 308 pd BitInv3;
!
!
! Canvas 7 - Synthesiser modules
!
echo #N canvas 560 150 450 330 Synth 0;
!
!
! Canvas 7.1
!
! 1st Wavetable
!
echo #N canvas  0 0 1267 719 table1 0;
echo #N canvas  0 0 450 300 graph1 0;
echo #X array   table1 259 float 1;
echo #A const   0;
echo #X coords  0 1.02 258 -1.02 258 130 1;
echo #X restore 69 103 graph;
echo #X msg 14  261 \; table1 cosinesum 256 0.2 -0.2 0.45 -0.2 0.2 -0.72 0.2;
echo #X obj 14  234 r load;
echo #X obj 13  300 r reset;
echo #X msg 13  324 \; table1 const 0 \;;
echo #X connect 2 0 1 0;
echo #X connect 3 0 4 0;
echo #X restore 220 20  pd table1;
!
!
! Canvas 7.2
!
! 2nd Wavetable
!
echo #N canvas  0 0 1267 723 table2 0;
echo #N canvas  0 0 450 300 graph1 0;
echo #X array   table2 259 float 1;
echo #A const   0;
echo #X coords  0 1.02 258 -1.02 258 130 1;
echo #X restore 73 78 graph;
echo #X msg 16  238 \; table2 cosinesum 256 0.2 -0.12 0.25 -0.2 0.2 -0.42 0.2;
echo #X obj 16  212 r load;
echo #X obj 17  279 r reset;
echo #X msg 17  306 \; table2 const 0 \;;
echo #X connect 2 0 1 0;
echo #X connect 3 0 4 0;
echo #X restore 220 60  pd table2;
!
!
! Canvas 7.3
!
! 3rd Wavetable
!
echo #N canvas  0 0 1267 719 table3 0;
echo #N canvas  0 0 450 300 graph1 0;
echo #X array   table3 259 float 1;
echo #A const   0;
echo #X coords  0 1.02 258 -1.02 258 130 1;
echo #X restore 52 54 graph;
echo #X msg 7   228 \; table3 cosinesum 256 0.2 -0.2 0.2 -0.35 0.2 -0.2 0.2;
echo #X obj 7   204 r load;
echo #X obj 7   265 r reset;
echo #X msg 7   287 \; table3 const 0 \;;
echo #X connect 2 0 1 0;
echo #X connect 3 0 4 0;
echo #X restore 220 100 pd table3;
!
!
! Canvas 7.4
!
! 1st audio generator
!
echo #N canvas 74 0 268 552 tone1 0;
echo #X obj 19 170 tabread scale;
echo #X obj 107 135 t b f;
echo #X obj 119 190 pow;
echo #X obj 81 249 *;
echo #X msg 107 161 2;
echo #X obj 81 326 *~ 0.1;
echo #X obj 19 -93 s keyIN1;
echo #X obj 19 -70 r keyOUT1;
echo #X obj 82 350 throw~ left;
echo #X obj 19 -119 mod %n(0);
echo #X obj 19 -144 r Xout1;
echo #X obj 112 303 r v1;
echo #X obj 19 -47 t f f;
echo #X obj 81 278 tabosc4~ table1;
echo #X obj 101 -39 r ModeIN1;
echo #X obj 64 75 int 1;
echo #X obj 144 81 int 0;
echo #X obj 126 21 + 1;
echo #X obj 64 22 t b;
echo #X obj 101 21 t b;
echo #X obj 169 -39 r OctIN1;
echo #X obj 107 219 * 130.8;
echo #X obj 64 -10 moses 1;
echo #X connect 0 0 3 0;
echo #X connect 1 0 4 0;
echo #X connect 1 1 2 1;
echo #X connect 2 0 21 0;
echo #X connect 3 0 13 0;
echo #X connect 4 0 2 0;
echo #X connect 5 0 8 0;
echo #X connect 7 0 12 0;
echo #X connect 9 0 6 0;
echo #X connect 10 0 9 0;
echo #X connect 11 0 5 1;
echo #X connect 12 0 0 0;
echo #X connect 12 1 22 0;
echo #X connect 13 0 5 0;
echo #X connect 14 0 22 1;
echo #X connect 15 0 1 0;
echo #X connect 16 0 1 0;
echo #X connect 17 0 15 1;
echo #X connect 18 0 15 0;
echo #X connect 19 0 16 0;
echo #X connect 20 0 17 0;
echo #X connect 20 0 16 1;
echo #X connect 21 0 3 1;
echo #X connect 22 0 18 0;
echo #X connect 22 1 19 0;
echo #X coords 0 0 1 1 200 140 0;
echo #X restore 120 20  pd tone1;
!
!
! Canvas 7.5
!
! 2nd audio generator
!
echo #N canvas 99 0 252 619 tone2 0;
echo #X obj 22 349 tabread scale;
echo #X obj 126 337 t b f;
echo #X obj 138 389 pow;
echo #X obj 113 457 *;
echo #X msg 126 360 2;
echo #X obj 113 536 *~ 0.1;
echo #X obj 113 563 throw~ left;
echo #X obj 22 38 mod %n(0);
echo #X obj 22 113 t f f;
echo #X obj 126 418 * 261.6;
echo #X obj 22 65 s keyIN2;
echo #X obj 22 88 r keyOUT2;
echo #X obj 22 13 r Xout2;
echo #X obj 113 486 tabosc4~ table2;
echo #X obj 144 511 r v2;
echo #X obj 46 240 int 1;
echo #X obj 126 246 int 0;
echo #X obj 108 186 + 1;
echo #X obj 46 187 t b;
echo #X obj 83 186 t b;
echo #X obj 83 126 r ModeIN2;
echo #X obj 151 126 r OctIN2;
echo #X obj 46 154 moses 1;
echo #X connect 0 0 3 0;
echo #X connect 1 0 4 0;
echo #X connect 1 1 2 1;
echo #X connect 2 0 9 0;
echo #X connect 3 0 13 0;
echo #X connect 4 0 2 0;
echo #X connect 5 0 6 0;
echo #X connect 7 0 10 0;
echo #X connect 8 0 0 0;
echo #X connect 8 0 22 0;
echo #X connect 9 0 3 1;
echo #X connect 11 0 8 0;
echo #X connect 12 0 7 0;
echo #X connect 13 0 5 0;
echo #X connect 14 0 5 1;
echo #X connect 15 0 1 0;
echo #X connect 16 0 1 0;
echo #X connect 17 0 15 1;
echo #X connect 18 0 15 0;
echo #X connect 19 0 16 0;
echo #X connect 20 0 22 1;
echo #X connect 21 0 17 0;
echo #X connect 21 0 16 1;
echo #X connect 22 0 18 0;
echo #X connect 22 1 19 0;
echo #X coords 0 0 1 1 200 140 0;
echo #X restore 120 60  pd tone2;
!
!
! Canvas 7.6
!
! 3rd audio generator
!
echo #N canvas 134 75 273 619 tone3 0;
echo #X obj 14 138 tabread scale;
echo #X obj 133 141 t b f;
echo #X obj 145 193 pow;
echo #X obj 120 261 *;
echo #X msg 133 164 2;
echo #X obj 121 341 *~ 0.1;
echo #X obj 120 372 throw~ left;
echo #X obj 14 -147 mod %n(0);
echo #X obj 14 -73 t f f;
echo #X obj 133 222 * 261.6;
echo #X obj 14 -173 r Xout3;
echo #X obj 14 -121 s keyIN3;
echo #X obj 14 -98 r keyOUT3;
echo #X obj 120 291 tabosc4~ table3;
echo #X obj 152 316 r v3;
echo #X obj 53 44 int 1;
echo #X obj 133 50 int 0;
echo #X obj 115 -10 + 1;
echo #X obj 53 -9 t b;
echo #X obj 90 -10 t b;
echo #X obj 90 -70 r ModeIN3;
echo #X obj 158 -70 r OctIN3;
echo #X obj 53 -42 moses 1;
echo #X connect 0 0 3 0;
echo #X connect 1 0 4 0;
echo #X connect 1 1 2 1;
echo #X connect 2 0 9 0;
echo #X connect 3 0 13 0;
echo #X connect 4 0 2 0;
echo #X connect 5 0 6 0;
echo #X connect 7 0 11 0;
echo #X connect 8 0 0 0;
echo #X connect 8 1 22 0;
echo #X connect 9 0 3 1;
echo #X connect 10 0 7 0;
echo #X connect 12 0 8 0;
echo #X connect 13 0 5 0;
echo #X connect 14 0 5 1;
echo #X connect 15 0 1 0;
echo #X connect 16 0 1 0;
echo #X connect 17 0 15 1;
echo #X connect 18 0 15 0;
echo #X connect 19 0 16 0;
echo #X connect 20 0 22 1;
echo #X connect 21 0 17 0;
echo #X connect 21 0 16 1;
echo #X connect 22 0 18 0;
echo #X connect 22 1 19 0;
echo #X coords 0 0 1 1 200 140 0;
echo #X restore 120 100 pd tone3;
!
!
!
! Canvas 7.7 - tuning table
!
echo #N canvas 0 0 450 660 tuning 0;
!
! Scale table
!
echo #X obj 30 15 r load;
echo #X obj 30 39 int;
echo #X obj 30 64 route 1 0;
echo #X msg 30 160 readout 1 \; scale resize %n+1(0) \; scale bounds 0 2 %n(0) 1 \; scale xticks 0 1 %n+1(0) \; scale xlabel 0.9 0 1 %listfactor(9) \; scale yticks 1 0.1 2 \; scale ylabel %n(0).5 1 2 \; scale 0 1 %listfactor(0) \;;
echo #X msg 54 94 readout 0 \; scale resize %n+1(0) \; scale bounds 0 2 %n(0) 1 \; scale const 1 \;;
echo #X connect 0 0 1 0;
echo #X connect 1 0 2 0;
echo #X connect 2 0 3 0;
echo #X connect 2 1 4 0;
echo #X restore 20  20  pd tuning;
!
!
!
! Canvas 7.8 - decoders and encoder
!
echo #N canvas 0 0 450 660 mux 0;
!
! 
!
echo #X text 133 14 Combinatorial decoder1: Clocks;
echo #X obj  55  14 r run;
echo #X obj  55  38 route 0 1 2 3 4 5 6 7;
!
!
! Clocks 0 
echo #X msg 60  55 0;
echo #X obj 60  72 s c3;
echo #X obj 95  72 s c2;
echo #X obj 130 72 s c1;
!
! Clocks 1
echo #X msg 170 55 1;
echo #X obj 170 72 s c1;
echo #X msg 205 55 0;
echo #X obj 205 72 s c3;
echo #X obj 240 72 s c2;
!
! Clocks 2
echo #X msg 280 55 1;
echo #X obj 280 72 s c2;
echo #X msg 315 55 0;
echo #X obj 315 72 s c3;
echo #X obj 350 72 s c1;
!
! Clocks 3
echo #X msg 390 55 1;
echo #X obj 390 72 s c2;
echo #X obj 425 72 s c1;
echo #X msg 425 55 0;
echo #X obj 460 72 s c3;
!
! Clocks 4
echo #X msg 500 55 1;
echo #X obj 500 72 s c3;
echo #X msg 535 55 0;
echo #X obj 535 72 s c2;
echo #X obj 570 72 s c1;
!
! Clocks 5
echo #X msg 610 55 1;
echo #X obj 610 72 s c3;
echo #X obj 645 72 s c1;
echo #X msg 680 55 0;
echo #X obj 680 72 s c2;
!
! Clocks 6
echo #X msg 720 55 1;
echo #X obj 720 72 s c3;
echo #X obj 755 72 s c2;
echo #X msg 790 55 0;
echo #X obj 790 72 s c1;
!
! Clocks 7
echo #X msg 830 55 1;
echo #X obj 830 72 s c3;
echo #X obj 865 72 s c2;
echo #X obj 900 72 s c1;
!
!
! for testing purposes
! 204 is 214
! 228 is 238
!
echo #X text 133 214 Combinatorial decoder2: Voices;
echo #X obj  55  214 r cut;
echo #X obj  55  238 route 0 1 2 3 4 5 6 7;
!
!
! Voices 0 
echo #X msg 60  255 0;
echo #X obj 60  272 s on3;
echo #X obj 95  272 s on2;
echo #X obj 130 272 s on1;
!
! Voices 1
echo #X msg 170 255 0.3;
echo #X obj 170 272 s on1;
echo #X msg 205 255 0;
echo #X obj 205 272 s on3;
echo #X obj 240 272 s on2;
!
! Voices 2
echo #X msg 280 255 0.3;
echo #X obj 280 272 s on2;
echo #X msg 315 255 0;
echo #X obj 315 272 s on3;
echo #X obj 350 272 s on1;
!
! Voices 3
echo #X msg 390 255 0.3;
echo #X obj 390 272 s on2;
echo #X obj 425 272 s on1;
echo #X msg 425 255 0;
echo #X obj 460 272 s on3;
!
! Voices 4
echo #X msg 500 255 0.3;
echo #X obj 500 272 s on3;
echo #X msg 535 255 0;
echo #X obj 535 272 s on2;
echo #X obj 570 272 s on1;
!
! Voices 5
echo #X msg 610 255 0.3;
echo #X obj 610 272 s on3;
echo #X obj 645 272 s on1;
echo #X msg 680 255 0;
echo #X obj 680 272 s on2;
!
! Voices 6
echo #X msg 720 255 0.3;
echo #X obj 720 272 s on3;
echo #X obj 755 272 s on2;
echo #X msg 790 255 0;
echo #X obj 790 272 s on1;
!
! Voices 7
echo #X msg 830 255 0.3;
echo #X obj 830 272 s on3;
echo #X obj 865 272 s on2;
echo #X obj 900 272 s on1;
!
!
!
echo #X text 97 508 Combinatorial encoder;
!
! Voices [82-85]
echo #X obj 99  530 r 1and2;
echo #X obj 153 530 r 1and3;
echo #X obj 204 530 r 2and3;
echo #X obj 263 530 r 1and2and3;
!
! Clocks [86-88]
echo #X obj 346 530 r step1;
echo #X obj 428 530 r step2;
echo #X obj 510 530 r step3;
!
! ??? [89-91]
echo #X obj 394 530 r p1;
echo #X obj 478 530 r p2;
echo #X obj 560 530 r p3;
!
! Mute OFF [92-94]
echo #X msg 353 547 \; vinit1 0.3 \;;
echo #X msg 434 547 \; vinit2 0.3 \;;
echo #X msg 515 547 \; vinit3 0.3 \;;
!
! Mute ON [95-97]
echo #X msg 151 547 \; vinit1 0 \;;
echo #X msg 217 547 \; vinit2 0 \;;
echo #X msg 285 547 \; vinit3 0 \;;
!
!
echo #X connect  1  0 2  0;
!
! Clocks 0
echo #X connect  2  0 3  0;
echo #X connect  3  0 4  0;
echo #X connect  3  0 5  0;
echo #X connect  3  0 6  0;
!
! Clocks 1
echo #X connect  2  1 7  0;
echo #X connect  2  1 9  0;
echo #X connect  7  0 8  0;
echo #X connect  9  0 10 0;
echo #X connect  9  0 11 0;
!
! Clocks 2
echo #X connect  2  2 12 0;
echo #X connect  2  2 14 0;
echo #X connect  12 0 13 0;
echo #X connect  14 0 15 0;
echo #X connect  14 0 16 0;
!
! Clocks 3
echo #X connect  2  3 17 0;
echo #X connect  2  3 20 0;
echo #X connect  17 0 18 0;
echo #X connect  17 0 19 0;
echo #X connect  20 0 21 0;
!
! Clocks 4
echo #X connect  2  4 22 0;
echo #X connect  2  4 24 0;
echo #X connect  22 0 23 0;
echo #X connect  24 0 25 0;
echo #X connect  24 0 26 0;
!
! Clocks 5
echo #X connect  2  5 27 0;
echo #X connect  2  5 30 0;
echo #X connect  27 0 28 0;
echo #X connect  27 0 29 0;
echo #X connect  30 0 31 0;
!
! Clocks 6
echo #X connect  2  6 32 0;
echo #X connect  2  6 35 0;
echo #X connect  32 0 33 0;
echo #X connect  32 0 34 0;
echo #X connect  35 0 36 0;
!
! Clocks 7
echo #X connect  2  7 37 0;
echo #X connect  37 0 38 0;
echo #X connect  37 0 39 0;
echo #X connect  37 0 40 0;
!
echo #X connect  42 0 43  0;
!
! Voices 0
echo #X connect  43 0 44 0;
echo #X connect  44 0 45 0;
echo #X connect  44 0 46 0;
echo #X connect  44 0 47 0;
!
! Voices 1
echo #X connect  43 1 48 0;
echo #X connect  43 1 50 0;
echo #X connect  48 0 49 0;
echo #X connect  50 0 51 0;
echo #X connect  50 0 52 0;
!
! Voices 2
echo #X connect  43 2 53 0;
echo #X connect  43 2 55 0;
echo #X connect  53 0 54 0;
echo #X connect  55 0 56 0;
echo #X connect  55 0 57 0;
!
! Voices 3
echo #X connect  43 3 58 0;
echo #X connect  43 3 61 0;
echo #X connect  58 0 59 0;
echo #X connect  58 0 60 0;
echo #X connect  61 0 62 0;
!
! Voices 4
echo #X connect  43 4 63 0;
echo #X connect  43 4 65 0;
echo #X connect  63 0 64 0;
echo #X connect  65 0 66 0;
echo #X connect  65 0 67 0;
!
! Voices 5
echo #X connect  43 5 68 0;
echo #X connect  43 5 71 0;
echo #X connect  68 0 69 0;
echo #X connect  68 0 70 0;
echo #X connect  71 0 72 0;
!
! Voices 6
echo #X connect  43 6 73 0;
echo #X connect  43 6 76 0;
echo #X connect  73 0 74 0;
echo #X connect  73 0 75 0;
echo #X connect  76 0 77 0;
!
! Voices 7
echo #X connect  43 7 78 0;
echo #X connect  78 0 79 0;
echo #X connect  78 0 80 0;
echo #X connect  78 0 81 0;
!
!
! Encoder 3
echo #X connect  83 0 93 0;
echo #X connect  83 0 94 0;
echo #X connect  83 0 98 0;
!
echo #X connect  84 0 93 0;
echo #X connect  84 0 95 0;
echo #X connect  84 0 97 0;
!
echo #X connect  85 0 96 0;
echo #X connect  85 0 94 0;
echo #X connect  85 0 95 0;
!
echo #X connect  86 0 93 0;
echo #X connect  86 0 94 0;
echo #X connect  86 0 95 0;
!
echo #X connect  87 0 93 0;
echo #X connect  88 0 94 0;
echo #X connect  89 0 95 0;
!
echo #X connect  90 0 93 0;
echo #X connect  91 0 94 0;
echo #X connect  92 0 95 0;
!
!
echo #X restore 20  100 pd mux;
!
!
!
! Canvas 7.9 - Master clock and timing chain
!
!
!echo #N canvas 0 0 1267 731 clock 0;
echo #N canvas 0 0 1267 707 clock 0;
echo #X obj 202 129 int;
echo #X obj 215 106 + 1;
echo #X obj 322 129 int;
echo #X obj 335 106 + 1;
echo #X obj 443 129 int;
echo #X obj 456 107 + 1;
echo #X obj 322 159 mod 2;
echo #X obj 443 157 mod 2;
echo #X obj 202 159 mod 2;
echo #X obj 202 183 == 0;
echo #X obj 322 183 == 0;
echo #X obj 443 182 == 0;
echo #X obj 171 238 spigot;
echo #X obj 291 238 spigot;
echo #X obj 412 238 spigot;
echo #X obj 227 137 r line1;
echo #X obj 347 137 r line2;
echo #X obj 468 135 r line3;
echo #X text 172 82 Clocks and timing chains;
echo #X obj 91 85 tgl 10 0 empty empty empty 0 -6 0 8 -262144 -1 -1 0 0.3;
echo #X obj 412 280 spigot;
echo #X obj 443 258 r step3;
echo #X obj 412 321 int;
echo #X obj 425 300 + 1;
echo #X obj 412 304 bng 10 250 50 0 empty empty empty 0 -6 0 8 -262144 -1 -1;
echo #X obj 291 279 spigot;
echo #X obj 291 319 int;
echo #X obj 304 298 + 1;
echo #X obj 291 302 bng 10 250 50 0 empty empty empty 0 -6 0 8 -262144 -1 -1;
echo #X obj 322 258 r step2;
echo #X obj 171 280 spigot;
echo #X obj 171 322 int;
echo #X obj 184 301 + 1;
echo #X obj 171 304 bng 10 250 50 0 empty empty empty 0 -6 0 8 -262144 -1 -1;
echo #X obj 202 258 r step1;
echo #X obj 171 341 mod %n(0);
echo #X obj 291 339 mod %n(0);
echo #X obj 412 340 mod %n(0);
echo #X obj 91 112 metro 180;
echo #X obj 412 362 s Xin3;
echo #X obj 171 362 s Xin1;
echo #X obj 291 360 s Xin2;
echo #X obj 91 221 t b b b;
echo #X obj 91 56 r step0;
echo #X obj 45 129 s sync;
echo #X connect 0 0 8 0;
echo #X connect 0 0 1 0;
echo #X connect 1 0 0 1;
echo #X connect 2 0 3 0;
echo #X connect 2 0 6 0;
echo #X connect 3 0 2 1;
echo #X connect 4 0 5 0;
echo #X connect 4 0 7 0;
echo #X connect 5 0 4 1;
echo #X connect 6 0 10 0;
echo #X connect 7 0 11 0;
echo #X connect 8 0 9 0;
echo #X connect 9 0 12 1;
echo #X connect 10 0 13 1;
echo #X connect 11 0 14 1;
echo #X connect 12 0 30 0;
echo #X connect 13 0 25 0;
echo #X connect 14 0 20 0;
echo #X connect 15 0 8 1;
echo #X connect 16 0 6 1;
echo #X connect 17 0 7 1;
echo #X connect 19 0 38 0;
echo #X connect 20 0 24 0;
echo #X connect 21 0 20 1;
echo #X connect 22 0 23 0;
echo #X connect 22 0 37 0;
echo #X connect 23 0 22 1;
echo #X connect 24 0 22 0;
echo #X connect 25 0 28 0;
echo #X connect 26 0 27 0;
echo #X connect 26 0 36 0;
echo #X connect 27 0 26 1;
echo #X connect 28 0 26 0;
echo #X connect 29 0 25 1;
echo #X connect 30 0 33 0;
echo #X connect 31 0 32 0;
echo #X connect 31 0 35 0;
echo #X connect 32 0 31 1;
echo #X connect 33 0 31 0;
echo #X connect 34 0 30 1;
echo #X connect 35 0 40 0;
echo #X connect 36 0 41 0;
echo #X connect 37 0 39 0;
echo #X connect 38 0 0 0;
echo #X connect 38 0 4 0;
echo #X connect 38 0 2 0;
echo #X connect 38 0 42 0;
echo #X connect 38 0 44 0;
echo #X connect 42 0 14 0;
echo #X connect 42 1 13 0;
echo #X connect 42 2 12 0;
echo #X connect 43 0 19 0;
echo #X restore 20  60  pd clock;
!
! Canvas 7.10 - Rhythmic map
!
echo #N canvas 0 0 1267 731 map 0;
echo #X obj 110 83 int;
echo #X obj 123 59 + 1;
echo #X msg 95 170 3;
echo #X msg 140 170 1;
echo #X msg 170 170 3;
echo #X msg 260 170 1;
echo #X msg 328 170 3;
echo #X msg 428 170 1;
echo #X obj 95 141 route 0 1 2 3 4 5 6 7 8 9 10 11;
echo #X obj 308 141 route 12 13 14 15 16 17 18 19 20 21 22 23;
echo #X msg 468 170 2;
echo #X msg 95 192 4;
echo #X msg 155 192 1;
echo #X msg 170 192 2;
echo #X msg 200 192 1;
echo #X msg 215 192 4;
echo #X msg 308 192 1;
echo #X msg 328 192 2;
echo #X msg 368 192 1;
echo #X msg 388 192 3;
echo #X msg 448 192 1;
echo #X msg 468 192 3;
echo #X msg 528 192 1;
echo #X msg 95 215 1;
echo #X msg 125 215 3;
echo #X msg 215 215 1;
echo #X msg 245 215 3;
echo #X msg 328 215 2;
echo #X msg 368 215 1;
echo #X msg 408 215 2;
echo #X msg 487 215 3;
echo #X obj 31 209 s line2;
echo #X obj 31 187 s line1;
echo #X obj 32 232 s line3;
echo #X msg 168 215 3;
echo #X msg 110 215 1;
echo #X msg 230 215 1;
echo #X msg 388 215 1;
echo #X msg 448 215 2;
echo #X msg 155 170 1;
echo #X msg 215 170 3;
echo #X msg 308 170 1;
echo #X msg 388 170 2;
echo #X msg 448 170 1;
echo #X msg 508 170 2;
echo #X text 159 122 Rhythmic map;
echo #X obj 110 124 mod 24;
echo #X obj 110 20 r sync;
echo #X connect 0 0 1 0;
echo #X connect 0 0 46 0;
echo #X connect 1 0 0 1;
echo #X connect 2 0 32 0;
echo #X connect 3 0 32 0;
echo #X connect 4 0 32 0;
echo #X connect 5 0 32 0;
echo #X connect 6 0 32 0;
echo #X connect 7 0 32 0;
echo #X connect 8 0 2 0;
echo #X connect 8 0 11 0;
echo #X connect 8 0 23 0;
echo #X connect 8 1 35 0;
echo #X connect 8 2 24 0;
echo #X connect 8 3 3 0;
echo #X connect 8 4 12 0;
echo #X connect 8 4 39 0;
echo #X connect 8 5 4 0;
echo #X connect 8 5 13 0;
echo #X connect 8 5 34 0;
echo #X connect 8 7 14 0;
echo #X connect 8 8 15 0;
echo #X connect 8 8 25 0;
echo #X connect 8 8 40 0;
echo #X connect 8 9 36 0;
echo #X connect 8 10 26 0;
echo #X connect 8 11 5 0;
echo #X connect 9 0 16 0;
echo #X connect 9 0 41 0;
echo #X connect 9 1 6 0;
echo #X connect 9 1 17 0;
echo #X connect 9 1 27 0;
echo #X connect 9 3 18 0;
echo #X connect 9 3 28 0;
echo #X connect 9 4 19 0;
echo #X connect 9 4 37 0;
echo #X connect 9 4 42 0;
echo #X connect 9 5 29 0;
echo #X connect 9 6 7 0;
echo #X connect 9 7 20 0;
echo #X connect 9 7 38 0;
echo #X connect 9 7 43 0;
echo #X connect 9 8 10 0;
echo #X connect 9 8 21 0;
echo #X connect 9 9 30 0;
echo #X connect 9 10 44 0;
echo #X connect 9 11 22 0;
echo #X connect 10 0 32 0;
echo #X connect 11 0 31 0;
echo #X connect 12 0 31 0;
echo #X connect 13 0 31 0;
echo #X connect 14 0 31 0;
echo #X connect 15 0 31 0;
echo #X connect 16 0 31 0;
echo #X connect 17 0 31 0;
echo #X connect 18 0 31 0;
echo #X connect 19 0 31 0;
echo #X connect 20 0 31 0;
echo #X connect 21 0 31 0;
echo #X connect 22 0 31 0;
echo #X connect 23 0 33 0;
echo #X connect 24 0 33 0;
echo #X connect 25 0 33 0;
echo #X connect 26 0 33 0;
echo #X connect 27 0 33 0;
echo #X connect 28 0 33 0;
echo #X connect 29 0 33 0;
echo #X connect 30 0 33 0;
echo #X connect 34 0 33 0;
echo #X connect 35 0 33 0;
echo #X connect 36 0 33 0;
echo #X connect 37 0 33 0;
echo #X connect 38 0 33 0;
echo #X connect 39 0 32 0;
echo #X connect 40 0 32 0;
echo #X connect 41 0 32 0;
echo #X connect 42 0 32 0;
echo #X connect 43 0 32 0;
echo #X connect 44 0 32 0;
echo #X connect 46 0 8 0;
echo #X connect 46 0 9 0;
echo #X connect 47 0 0 0;
echo #X restore 20  120  pd map;
!
echo #X restore 635 318 pd Synth;
!
! Canvas 8
!
! Audio Mixer
!
echo #N canvas 66 417 517 741 Mixer 0;
echo #X obj 176 -10 r play;
echo #X obj 40 170 catch~ left;
echo #X obj 41 270 dac~ 1 2;
echo #X obj 200 274 dac~ 1 2;
echo #X obj 244 171 catch~ right;
echo #X obj 131 273 dac~ 1 2;
echo #X obj 243 220 *~ 0.1;
echo #X obj 274 195 r vol;
echo #X obj 243 246 hip~;
echo #X obj 40 217 *~ 0.1;
echo #X obj 71 193 r vol;
echo #X obj 40 243 hip~;
echo #X obj 131 219 *~ 0.1;
echo #X obj 162 194 r vol;
echo #X obj 131 245 hip~;
echo #X obj 132 172 catch~ both;
echo #X obj 51 29 spigot;
echo #X obj 145 29 spigot;
echo #X obj 82 7 == 0;
echo #X obj 51 7 bng 15 250 50 0 empty empty empty 0 -6 0 8 -262144 -1 -1 ;
echo #X obj 145 7 bng 15 250 50 0 empty empty empty 0 -6 0 8 -262144 -1 -1;
echo #X msg 145 57 \; on3 0.3 \; on2 0.3 \; on1 0.3 \; on0 0.3;
echo #X msg 51 57 \; on1 0 \; on2 0 \; on3 0 \; on0 0;
echo #X obj 254 -8 r play;
echo #X obj 254 14 route 0 1;
echo #X msg 254 31 \; pd dsp 0 \;;
echo #X msg 319 31 \; pd dsp 1 \;;
echo #X connect 0 0 17 1;
echo #X connect 0 0 18 0;
echo #X connect 0 0 19 0;
echo #X connect 0 0 20 0;
echo #X connect 1 0 9 0;
echo #X connect 4 0 6 0;
echo #X connect 6 0 8 0;
echo #X connect 7 0 6 1;
echo #X connect 8 0 3 1;
echo #X connect 9 0 11 0;
echo #X connect 10 0 9 1;
echo #X connect 11 0 2 0;
echo #X connect 12 0 14 0;
echo #X connect 13 0 12 1;
echo #X connect 14 0 5 0;
echo #X connect 15 0 12 0;
echo #X connect 16 0 22 0;
echo #X connect 17 0 21 0;
echo #X connect 18 0 16 1;
echo #X connect 19 0 16 0;
echo #X connect 20 0 17 0;
echo #X connect 23 0 24 0;
echo #X connect 24 0 25 0;
echo #X connect 24 1 26 0;
echo #X restore 635 302 pd Mixer;
!
close
!
! This parent has been forced to clean up after its kids
!
remove ordinal.cmd
